package com.yobotics.exampleSimulations.agileHexapod;

import java.util.ArrayList;

import com.yobotics.simulationconstructionset.DoubleYoVariable;

public class AgileHexapodControllerBase
{
   protected AgileHexapodRobot rob;

   // These are the variables that are automatically created when the robot is created:
   DoubleYoVariable t;
   DoubleYoVariable q_x, q_y, q_z, qd_x, qd_y, qd_z, qdd_x, qdd_y, qdd_z, q_qs;
   DoubleYoVariable q_qx, q_qy, q_qz, qd_wx, qd_wy, qd_wz, qdd_wx, qdd_wy, qdd_wz;
   DoubleYoVariable gc_body1_x, gc_body1_y, gc_body1_z, gc_body1_dx, gc_body1_dy, gc_body1_dz, gc_body1_fx, gc_body1_fy, gc_body1_fz, gc_body1_px;
   DoubleYoVariable gc_body1_py, gc_body1_pz, gc_body1_tdx, gc_body1_tdy, gc_body1_tdz, gc_body1_fs, gc_body1_slip, gc_body1_coll;
   DoubleYoVariable gc_body2_x, gc_body2_y, gc_body2_z, gc_body2_dx, gc_body2_dy, gc_body2_dz, gc_body2_fx, gc_body2_fy, gc_body2_fz, gc_body2_px;
   DoubleYoVariable gc_body2_py, gc_body2_pz, gc_body2_tdx, gc_body2_tdy, gc_body2_tdz, gc_body2_fs, gc_body2_slip, gc_body2_coll;
   DoubleYoVariable gc_body3_x, gc_body3_y, gc_body3_z, gc_body3_dx, gc_body3_dy, gc_body3_dz, gc_body3_fx, gc_body3_fy, gc_body3_fz, gc_body3_px;
   DoubleYoVariable gc_body3_py, gc_body3_pz, gc_body3_tdx, gc_body3_tdy, gc_body3_tdz, gc_body3_fs, gc_body3_slip, gc_body3_coll;
   DoubleYoVariable gc_body4_x, gc_body4_y, gc_body4_z, gc_body4_dx, gc_body4_dy, gc_body4_dz, gc_body4_fx, gc_body4_fy, gc_body4_fz, gc_body4_px;
   DoubleYoVariable gc_body4_py, gc_body4_pz, gc_body4_tdx, gc_body4_tdy, gc_body4_tdz, gc_body4_fs, gc_body4_slip, gc_body4_coll;
   DoubleYoVariable q_hip1_z, qd_hip1_z, qdd_hip1_z, tau_hip1_z, tau_damp_hip1_z;
   DoubleYoVariable q_hip1_x, qd_hip1_x, qdd_hip1_x, tau_hip1_x, tau_damp_hip1_x;
   DoubleYoVariable q_knee1, qd_knee1, qdd_knee1, tau_knee1, tau_damp_knee1;
   DoubleYoVariable gc_foot1_x, gc_foot1_y, gc_foot1_z, gc_foot1_dx, gc_foot1_dy, gc_foot1_dz, gc_foot1_fx, gc_foot1_fy, gc_foot1_fz, gc_foot1_px;
   DoubleYoVariable gc_foot1_py, gc_foot1_pz, gc_foot1_tdx, gc_foot1_tdy, gc_foot1_tdz, gc_foot1_fs, gc_foot1_slip, gc_foot1_coll;
   DoubleYoVariable q_hip2_z, qd_hip2_z, qdd_hip2_z, tau_hip2_z, tau_damp_hip2_z;
   DoubleYoVariable q_hip2_x, qd_hip2_x, qdd_hip2_x, tau_hip2_x, tau_damp_hip2_x;
   DoubleYoVariable q_knee2, qd_knee2, qdd_knee2, tau_knee2, tau_damp_knee2;
   DoubleYoVariable gc_foot2_x, gc_foot2_y, gc_foot2_z, gc_foot2_dx, gc_foot2_dy, gc_foot2_dz, gc_foot2_fx, gc_foot2_fy, gc_foot2_fz, gc_foot2_px;
   DoubleYoVariable gc_foot2_py, gc_foot2_pz, gc_foot2_tdx, gc_foot2_tdy, gc_foot2_tdz, gc_foot2_fs, gc_foot2_slip, gc_foot2_coll;
   DoubleYoVariable q_hip3_z, qd_hip3_z, qdd_hip3_z, tau_hip3_z, tau_damp_hip3_z;
   DoubleYoVariable q_hip3_x, qd_hip3_x, qdd_hip3_x, tau_hip3_x, tau_damp_hip3_x;
   DoubleYoVariable q_knee3, qd_knee3, qdd_knee3, tau_knee3, tau_damp_knee3;
   DoubleYoVariable gc_foot3_x, gc_foot3_y, gc_foot3_z, gc_foot3_dx, gc_foot3_dy, gc_foot3_dz, gc_foot3_fx, gc_foot3_fy, gc_foot3_fz, gc_foot3_px;
   DoubleYoVariable gc_foot3_py, gc_foot3_pz, gc_foot3_tdx, gc_foot3_tdy, gc_foot3_tdz, gc_foot3_fs, gc_foot3_slip, gc_foot3_coll;
   DoubleYoVariable q_hip4_z, qd_hip4_z, qdd_hip4_z, tau_hip4_z, tau_damp_hip4_z;
   DoubleYoVariable q_hip4_x, qd_hip4_x, qdd_hip4_x, tau_hip4_x, tau_damp_hip4_x;
   DoubleYoVariable q_knee4, qd_knee4, qdd_knee4, tau_knee4, tau_damp_knee4;
   DoubleYoVariable gc_foot4_x, gc_foot4_y, gc_foot4_z, gc_foot4_dx, gc_foot4_dy, gc_foot4_dz, gc_foot4_fx, gc_foot4_fy, gc_foot4_fz, gc_foot4_px;
   DoubleYoVariable gc_foot4_py, gc_foot4_pz, gc_foot4_tdx, gc_foot4_tdy, gc_foot4_tdz, gc_foot4_fs, gc_foot4_slip, gc_foot4_coll;
   DoubleYoVariable q_hip5_z, qd_hip5_z, qdd_hip5_z, tau_hip5_z, tau_damp_hip5_z;
   DoubleYoVariable q_hip5_x, qd_hip5_x, qdd_hip5_x, tau_hip5_x, tau_damp_hip5_x;
   DoubleYoVariable q_knee5, qd_knee5, qdd_knee5, tau_knee5, tau_damp_knee5;
   DoubleYoVariable gc_foot5_x, gc_foot5_y, gc_foot5_z, gc_foot5_dx, gc_foot5_dy, gc_foot5_dz, gc_foot5_fx, gc_foot5_fy, gc_foot5_fz, gc_foot5_px;
   DoubleYoVariable gc_foot5_py, gc_foot5_pz, gc_foot5_tdx, gc_foot5_tdy, gc_foot5_tdz, gc_foot5_fs, gc_foot5_slip, gc_foot5_coll;
   DoubleYoVariable q_hip6_z, qd_hip6_z, qdd_hip6_z, tau_hip6_z, tau_damp_hip6_z;
   DoubleYoVariable q_hip6_x, qd_hip6_x, qdd_hip6_x, tau_hip6_x, tau_damp_hip6_x;
   DoubleYoVariable q_knee6, qd_knee6, qdd_knee6, tau_knee6, tau_damp_knee6;
   DoubleYoVariable gc_foot6_x, gc_foot6_y, gc_foot6_z, gc_foot6_dx, gc_foot6_dy, gc_foot6_dz, gc_foot6_fx, gc_foot6_fy, gc_foot6_fz, gc_foot6_px;
   DoubleYoVariable gc_foot6_py, gc_foot6_pz, gc_foot6_tdx, gc_foot6_tdy, gc_foot6_tdz, gc_foot6_fs, gc_foot6_slip, gc_foot6_coll;
   DoubleYoVariable q_pend1, qd_pend1, qdd_pend1, tau_pend1;
   DoubleYoVariable q_pend2, qd_pend2, qdd_pend2, tau_pend2;
   DoubleYoVariable gc_pend_end_x, gc_pend_end_y, gc_pend_end_z, gc_pend_end_dx, gc_pend_end_dy, gc_pend_end_dz, gc_pend_end_fx, gc_pend_end_fy, gc_pend_end_fz,
              gc_pend_end_px;
   DoubleYoVariable gc_pend_end_py, gc_pend_end_pz, gc_pend_end_tdx, gc_pend_end_tdy, gc_pend_end_tdz, gc_pend_end_fs, gc_pend_end_slip, gc_pend_end_coll;

   // User defined control variables will be placed in this ArrayList when they are registered:
   ArrayList<DoubleYoVariable> controlVars;

   public AgileHexapodControllerBase(AgileHexapodRobot rob)
   {
      this.rob = rob;

      // Get the variables that are stored with the robot:

      t = (DoubleYoVariable)rob.getVariable("t");

      q_x = (DoubleYoVariable)rob.getVariable("q_x");
      q_y = (DoubleYoVariable)rob.getVariable("q_y");
      q_z = (DoubleYoVariable)rob.getVariable("q_z");
      qd_x = (DoubleYoVariable)rob.getVariable("qd_x");
      qd_y = (DoubleYoVariable)rob.getVariable("qd_y");
      qd_z = (DoubleYoVariable)rob.getVariable("qd_z");
      qdd_x = (DoubleYoVariable)rob.getVariable("qdd_x");
      qdd_y = (DoubleYoVariable)rob.getVariable("qdd_y");
      qdd_z = (DoubleYoVariable)rob.getVariable("qdd_z");
      q_qs = (DoubleYoVariable)rob.getVariable("q_qs");
      q_qx = (DoubleYoVariable)rob.getVariable("q_qx");
      q_qy = (DoubleYoVariable)rob.getVariable("q_qy");
      q_qz = (DoubleYoVariable)rob.getVariable("q_qz");
      qd_wx = (DoubleYoVariable)rob.getVariable("qd_wx");
      qd_wy = (DoubleYoVariable)rob.getVariable("qd_wy");
      qd_wz = (DoubleYoVariable)rob.getVariable("qd_wz");
      qdd_wx = (DoubleYoVariable)rob.getVariable("qdd_wx");
      qdd_wy = (DoubleYoVariable)rob.getVariable("qdd_wy");
      qdd_wz = (DoubleYoVariable)rob.getVariable("qdd_wz");
      gc_body1_x = (DoubleYoVariable)rob.getVariable("gc_body1_x");
      gc_body1_y = (DoubleYoVariable)rob.getVariable("gc_body1_y");
      gc_body1_z = (DoubleYoVariable)rob.getVariable("gc_body1_z");
      gc_body1_dx = (DoubleYoVariable)rob.getVariable("gc_body1_dx");
      gc_body1_dy = (DoubleYoVariable)rob.getVariable("gc_body1_dy");
      gc_body1_dz = (DoubleYoVariable)rob.getVariable("gc_body1_dz");
      gc_body1_fx = (DoubleYoVariable)rob.getVariable("gc_body1_fx");
      gc_body1_fy = (DoubleYoVariable)rob.getVariable("gc_body1_fy");
      gc_body1_fz = (DoubleYoVariable)rob.getVariable("gc_body1_fz");
      gc_body1_px = (DoubleYoVariable)rob.getVariable("gc_body1_px");
      gc_body1_py = (DoubleYoVariable)rob.getVariable("gc_body1_py");
      gc_body1_pz = (DoubleYoVariable)rob.getVariable("gc_body1_pz");
      gc_body1_tdx = (DoubleYoVariable)rob.getVariable("gc_body1_tdx");
      gc_body1_tdy = (DoubleYoVariable)rob.getVariable("gc_body1_tdy");
      gc_body1_tdz = (DoubleYoVariable)rob.getVariable("gc_body1_tdz");
      gc_body1_fs = (DoubleYoVariable)rob.getVariable("gc_body1_fs");
      gc_body1_slip = (DoubleYoVariable)rob.getVariable("gc_body1_slip");
      gc_body1_coll = (DoubleYoVariable)rob.getVariable("gc_body1_coll");
      gc_body2_x = (DoubleYoVariable)rob.getVariable("gc_body2_x");
      gc_body2_y = (DoubleYoVariable)rob.getVariable("gc_body2_y");
      gc_body2_z = (DoubleYoVariable)rob.getVariable("gc_body2_z");
      gc_body2_dx = (DoubleYoVariable)rob.getVariable("gc_body2_dx");
      gc_body2_dy = (DoubleYoVariable)rob.getVariable("gc_body2_dy");
      gc_body2_dz = (DoubleYoVariable)rob.getVariable("gc_body2_dz");
      gc_body2_fx = (DoubleYoVariable)rob.getVariable("gc_body2_fx");
      gc_body2_fy = (DoubleYoVariable)rob.getVariable("gc_body2_fy");
      gc_body2_fz = (DoubleYoVariable)rob.getVariable("gc_body2_fz");
      gc_body2_px = (DoubleYoVariable)rob.getVariable("gc_body2_px");
      gc_body2_py = (DoubleYoVariable)rob.getVariable("gc_body2_py");
      gc_body2_pz = (DoubleYoVariable)rob.getVariable("gc_body2_pz");
      gc_body2_tdx = (DoubleYoVariable)rob.getVariable("gc_body2_tdx");
      gc_body2_tdy = (DoubleYoVariable)rob.getVariable("gc_body2_tdy");
      gc_body2_tdz = (DoubleYoVariable)rob.getVariable("gc_body2_tdz");
      gc_body2_fs = (DoubleYoVariable)rob.getVariable("gc_body2_fs");
      gc_body2_slip = (DoubleYoVariable)rob.getVariable("gc_body2_slip");
      gc_body2_coll = (DoubleYoVariable)rob.getVariable("gc_body2_coll");
      gc_body3_x = (DoubleYoVariable)rob.getVariable("gc_body3_x");
      gc_body3_y = (DoubleYoVariable)rob.getVariable("gc_body3_y");
      gc_body3_z = (DoubleYoVariable)rob.getVariable("gc_body3_z");
      gc_body3_dx = (DoubleYoVariable)rob.getVariable("gc_body3_dx");
      gc_body3_dy = (DoubleYoVariable)rob.getVariable("gc_body3_dy");
      gc_body3_dz = (DoubleYoVariable)rob.getVariable("gc_body3_dz");
      gc_body3_fx = (DoubleYoVariable)rob.getVariable("gc_body3_fx");
      gc_body3_fy = (DoubleYoVariable)rob.getVariable("gc_body3_fy");
      gc_body3_fz = (DoubleYoVariable)rob.getVariable("gc_body3_fz");
      gc_body3_px = (DoubleYoVariable)rob.getVariable("gc_body3_px");
      gc_body3_py = (DoubleYoVariable)rob.getVariable("gc_body3_py");
      gc_body3_pz = (DoubleYoVariable)rob.getVariable("gc_body3_pz");
      gc_body3_tdx = (DoubleYoVariable)rob.getVariable("gc_body3_tdx");
      gc_body3_tdy = (DoubleYoVariable)rob.getVariable("gc_body3_tdy");
      gc_body3_tdz = (DoubleYoVariable)rob.getVariable("gc_body3_tdz");
      gc_body3_fs = (DoubleYoVariable)rob.getVariable("gc_body3_fs");
      gc_body3_slip = (DoubleYoVariable)rob.getVariable("gc_body3_slip");
      gc_body3_coll = (DoubleYoVariable)rob.getVariable("gc_body3_coll");
      gc_body4_x = (DoubleYoVariable)rob.getVariable("gc_body4_x");
      gc_body4_y = (DoubleYoVariable)rob.getVariable("gc_body4_y");
      gc_body4_z = (DoubleYoVariable)rob.getVariable("gc_body4_z");
      gc_body4_dx = (DoubleYoVariable)rob.getVariable("gc_body4_dx");
      gc_body4_dy = (DoubleYoVariable)rob.getVariable("gc_body4_dy");
      gc_body4_dz = (DoubleYoVariable)rob.getVariable("gc_body4_dz");
      gc_body4_fx = (DoubleYoVariable)rob.getVariable("gc_body4_fx");
      gc_body4_fy = (DoubleYoVariable)rob.getVariable("gc_body4_fy");
      gc_body4_fz = (DoubleYoVariable)rob.getVariable("gc_body4_fz");
      gc_body4_px = (DoubleYoVariable)rob.getVariable("gc_body4_px");
      gc_body4_py = (DoubleYoVariable)rob.getVariable("gc_body4_py");
      gc_body4_pz = (DoubleYoVariable)rob.getVariable("gc_body4_pz");
      gc_body4_tdx = (DoubleYoVariable)rob.getVariable("gc_body4_tdx");
      gc_body4_tdy = (DoubleYoVariable)rob.getVariable("gc_body4_tdy");
      gc_body4_tdz = (DoubleYoVariable)rob.getVariable("gc_body4_tdz");
      gc_body4_fs = (DoubleYoVariable)rob.getVariable("gc_body4_fs");
      gc_body4_slip = (DoubleYoVariable)rob.getVariable("gc_body4_slip");
      gc_body4_coll = (DoubleYoVariable)rob.getVariable("gc_body4_coll");
      q_hip1_z = (DoubleYoVariable)rob.getVariable("q_hip1_z");
      qd_hip1_z = (DoubleYoVariable)rob.getVariable("qd_hip1_z");
      qdd_hip1_z = (DoubleYoVariable)rob.getVariable("qdd_hip1_z");
      tau_hip1_z = (DoubleYoVariable)rob.getVariable("tau_hip1_z");
      tau_damp_hip1_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip1_z");
      q_hip1_x = (DoubleYoVariable)rob.getVariable("q_hip1_x");
      qd_hip1_x = (DoubleYoVariable)rob.getVariable("qd_hip1_x");
      qdd_hip1_x = (DoubleYoVariable)rob.getVariable("qdd_hip1_x");
      tau_hip1_x = (DoubleYoVariable)rob.getVariable("tau_hip1_x");
      tau_damp_hip1_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip1_x");
      q_knee1 = (DoubleYoVariable)rob.getVariable("q_knee1");
      qd_knee1 = (DoubleYoVariable)rob.getVariable("qd_knee1");
      qdd_knee1 = (DoubleYoVariable)rob.getVariable("qdd_knee1");
      tau_knee1 = (DoubleYoVariable)rob.getVariable("tau_knee1");
      tau_damp_knee1 = (DoubleYoVariable)rob.getVariable("tau_damp_knee1");
      gc_foot1_x = (DoubleYoVariable)rob.getVariable("gc_foot1_x");
      gc_foot1_y = (DoubleYoVariable)rob.getVariable("gc_foot1_y");
      gc_foot1_z = (DoubleYoVariable)rob.getVariable("gc_foot1_z");
      gc_foot1_dx = (DoubleYoVariable)rob.getVariable("gc_foot1_dx");
      gc_foot1_dy = (DoubleYoVariable)rob.getVariable("gc_foot1_dy");
      gc_foot1_dz = (DoubleYoVariable)rob.getVariable("gc_foot1_dz");
      gc_foot1_fx = (DoubleYoVariable)rob.getVariable("gc_foot1_fx");
      gc_foot1_fy = (DoubleYoVariable)rob.getVariable("gc_foot1_fy");
      gc_foot1_fz = (DoubleYoVariable)rob.getVariable("gc_foot1_fz");
      gc_foot1_px = (DoubleYoVariable)rob.getVariable("gc_foot1_px");
      gc_foot1_py = (DoubleYoVariable)rob.getVariable("gc_foot1_py");
      gc_foot1_pz = (DoubleYoVariable)rob.getVariable("gc_foot1_pz");
      gc_foot1_tdx = (DoubleYoVariable)rob.getVariable("gc_foot1_tdx");
      gc_foot1_tdy = (DoubleYoVariable)rob.getVariable("gc_foot1_tdy");
      gc_foot1_tdz = (DoubleYoVariable)rob.getVariable("gc_foot1_tdz");
      gc_foot1_fs = (DoubleYoVariable)rob.getVariable("gc_foot1_fs");
      gc_foot1_slip = (DoubleYoVariable)rob.getVariable("gc_foot1_slip");
      gc_foot1_coll = (DoubleYoVariable)rob.getVariable("gc_foot1_coll");
      q_hip2_z = (DoubleYoVariable)rob.getVariable("q_hip2_z");
      qd_hip2_z = (DoubleYoVariable)rob.getVariable("qd_hip2_z");
      qdd_hip2_z = (DoubleYoVariable)rob.getVariable("qdd_hip2_z");
      tau_hip2_z = (DoubleYoVariable)rob.getVariable("tau_hip2_z");
      tau_damp_hip2_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip2_z");
      q_hip2_x = (DoubleYoVariable)rob.getVariable("q_hip2_x");
      qd_hip2_x = (DoubleYoVariable)rob.getVariable("qd_hip2_x");
      qdd_hip2_x = (DoubleYoVariable)rob.getVariable("qdd_hip2_x");
      tau_hip2_x = (DoubleYoVariable)rob.getVariable("tau_hip2_x");
      tau_damp_hip2_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip2_x");
      q_knee2 = (DoubleYoVariable)rob.getVariable("q_knee2");
      qd_knee2 = (DoubleYoVariable)rob.getVariable("qd_knee2");
      qdd_knee2 = (DoubleYoVariable)rob.getVariable("qdd_knee2");
      tau_knee2 = (DoubleYoVariable)rob.getVariable("tau_knee2");
      tau_damp_knee2 = (DoubleYoVariable)rob.getVariable("tau_damp_knee2");
      gc_foot2_x = (DoubleYoVariable)rob.getVariable("gc_foot2_x");
      gc_foot2_y = (DoubleYoVariable)rob.getVariable("gc_foot2_y");
      gc_foot2_z = (DoubleYoVariable)rob.getVariable("gc_foot2_z");
      gc_foot2_dx = (DoubleYoVariable)rob.getVariable("gc_foot2_dx");
      gc_foot2_dy = (DoubleYoVariable)rob.getVariable("gc_foot2_dy");
      gc_foot2_dz = (DoubleYoVariable)rob.getVariable("gc_foot2_dz");
      gc_foot2_fx = (DoubleYoVariable)rob.getVariable("gc_foot2_fx");
      gc_foot2_fy = (DoubleYoVariable)rob.getVariable("gc_foot2_fy");
      gc_foot2_fz = (DoubleYoVariable)rob.getVariable("gc_foot2_fz");
      gc_foot2_px = (DoubleYoVariable)rob.getVariable("gc_foot2_px");
      gc_foot2_py = (DoubleYoVariable)rob.getVariable("gc_foot2_py");
      gc_foot2_pz = (DoubleYoVariable)rob.getVariable("gc_foot2_pz");
      gc_foot2_tdx = (DoubleYoVariable)rob.getVariable("gc_foot2_tdx");
      gc_foot2_tdy = (DoubleYoVariable)rob.getVariable("gc_foot2_tdy");
      gc_foot2_tdz = (DoubleYoVariable)rob.getVariable("gc_foot2_tdz");
      gc_foot2_fs = (DoubleYoVariable)rob.getVariable("gc_foot2_fs");
      gc_foot2_slip = (DoubleYoVariable)rob.getVariable("gc_foot2_slip");
      gc_foot2_coll = (DoubleYoVariable)rob.getVariable("gc_foot2_coll");
      q_hip3_z = (DoubleYoVariable)rob.getVariable("q_hip3_z");
      qd_hip3_z = (DoubleYoVariable)rob.getVariable("qd_hip3_z");
      qdd_hip3_z = (DoubleYoVariable)rob.getVariable("qdd_hip3_z");
      tau_hip3_z = (DoubleYoVariable)rob.getVariable("tau_hip3_z");
      tau_damp_hip3_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip3_z");
      q_hip3_x = (DoubleYoVariable)rob.getVariable("q_hip3_x");
      qd_hip3_x = (DoubleYoVariable)rob.getVariable("qd_hip3_x");
      qdd_hip3_x = (DoubleYoVariable)rob.getVariable("qdd_hip3_x");
      tau_hip3_x = (DoubleYoVariable)rob.getVariable("tau_hip3_x");
      tau_damp_hip3_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip3_x");
      q_knee3 = (DoubleYoVariable)rob.getVariable("q_knee3");
      qd_knee3 = (DoubleYoVariable)rob.getVariable("qd_knee3");
      qdd_knee3 = (DoubleYoVariable)rob.getVariable("qdd_knee3");
      tau_knee3 = (DoubleYoVariable)rob.getVariable("tau_knee3");
      tau_damp_knee3 = (DoubleYoVariable)rob.getVariable("tau_damp_knee3");
      gc_foot3_x = (DoubleYoVariable)rob.getVariable("gc_foot3_x");
      gc_foot3_y = (DoubleYoVariable)rob.getVariable("gc_foot3_y");
      gc_foot3_z = (DoubleYoVariable)rob.getVariable("gc_foot3_z");
      gc_foot3_dx = (DoubleYoVariable)rob.getVariable("gc_foot3_dx");
      gc_foot3_dy = (DoubleYoVariable)rob.getVariable("gc_foot3_dy");
      gc_foot3_dz = (DoubleYoVariable)rob.getVariable("gc_foot3_dz");
      gc_foot3_fx = (DoubleYoVariable)rob.getVariable("gc_foot3_fx");
      gc_foot3_fy = (DoubleYoVariable)rob.getVariable("gc_foot3_fy");
      gc_foot3_fz = (DoubleYoVariable)rob.getVariable("gc_foot3_fz");
      gc_foot3_px = (DoubleYoVariable)rob.getVariable("gc_foot3_px");
      gc_foot3_py = (DoubleYoVariable)rob.getVariable("gc_foot3_py");
      gc_foot3_pz = (DoubleYoVariable)rob.getVariable("gc_foot3_pz");
      gc_foot3_tdx = (DoubleYoVariable)rob.getVariable("gc_foot3_tdx");
      gc_foot3_tdy = (DoubleYoVariable)rob.getVariable("gc_foot3_tdy");
      gc_foot3_tdz = (DoubleYoVariable)rob.getVariable("gc_foot3_tdz");
      gc_foot3_fs = (DoubleYoVariable)rob.getVariable("gc_foot3_fs");
      gc_foot3_slip = (DoubleYoVariable)rob.getVariable("gc_foot3_slip");
      gc_foot3_coll = (DoubleYoVariable)rob.getVariable("gc_foot3_coll");
      q_hip4_z = (DoubleYoVariable)rob.getVariable("q_hip4_z");
      qd_hip4_z = (DoubleYoVariable)rob.getVariable("qd_hip4_z");
      qdd_hip4_z = (DoubleYoVariable)rob.getVariable("qdd_hip4_z");
      tau_hip4_z = (DoubleYoVariable)rob.getVariable("tau_hip4_z");
      tau_damp_hip4_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip4_z");
      q_hip4_x = (DoubleYoVariable)rob.getVariable("q_hip4_x");
      qd_hip4_x = (DoubleYoVariable)rob.getVariable("qd_hip4_x");
      qdd_hip4_x = (DoubleYoVariable)rob.getVariable("qdd_hip4_x");
      tau_hip4_x = (DoubleYoVariable)rob.getVariable("tau_hip4_x");
      tau_damp_hip4_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip4_x");
      q_knee4 = (DoubleYoVariable)rob.getVariable("q_knee4");
      qd_knee4 = (DoubleYoVariable)rob.getVariable("qd_knee4");
      qdd_knee4 = (DoubleYoVariable)rob.getVariable("qdd_knee4");
      tau_knee4 = (DoubleYoVariable)rob.getVariable("tau_knee4");
      tau_damp_knee4 = (DoubleYoVariable)rob.getVariable("tau_damp_knee4");
      gc_foot4_x = (DoubleYoVariable)rob.getVariable("gc_foot4_x");
      gc_foot4_y = (DoubleYoVariable)rob.getVariable("gc_foot4_y");
      gc_foot4_z = (DoubleYoVariable)rob.getVariable("gc_foot4_z");
      gc_foot4_dx = (DoubleYoVariable)rob.getVariable("gc_foot4_dx");
      gc_foot4_dy = (DoubleYoVariable)rob.getVariable("gc_foot4_dy");
      gc_foot4_dz = (DoubleYoVariable)rob.getVariable("gc_foot4_dz");
      gc_foot4_fx = (DoubleYoVariable)rob.getVariable("gc_foot4_fx");
      gc_foot4_fy = (DoubleYoVariable)rob.getVariable("gc_foot4_fy");
      gc_foot4_fz = (DoubleYoVariable)rob.getVariable("gc_foot4_fz");
      gc_foot4_px = (DoubleYoVariable)rob.getVariable("gc_foot4_px");
      gc_foot4_py = (DoubleYoVariable)rob.getVariable("gc_foot4_py");
      gc_foot4_pz = (DoubleYoVariable)rob.getVariable("gc_foot4_pz");
      gc_foot4_tdx = (DoubleYoVariable)rob.getVariable("gc_foot4_tdx");
      gc_foot4_tdy = (DoubleYoVariable)rob.getVariable("gc_foot4_tdy");
      gc_foot4_tdz = (DoubleYoVariable)rob.getVariable("gc_foot4_tdz");
      gc_foot4_fs = (DoubleYoVariable)rob.getVariable("gc_foot4_fs");
      gc_foot4_slip = (DoubleYoVariable)rob.getVariable("gc_foot4_slip");
      gc_foot4_coll = (DoubleYoVariable)rob.getVariable("gc_foot4_coll");
      q_hip5_z = (DoubleYoVariable)rob.getVariable("q_hip5_z");
      qd_hip5_z = (DoubleYoVariable)rob.getVariable("qd_hip5_z");
      qdd_hip5_z = (DoubleYoVariable)rob.getVariable("qdd_hip5_z");
      tau_hip5_z = (DoubleYoVariable)rob.getVariable("tau_hip5_z");
      tau_damp_hip5_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip5_z");
      q_hip5_x = (DoubleYoVariable)rob.getVariable("q_hip5_x");
      qd_hip5_x = (DoubleYoVariable)rob.getVariable("qd_hip5_x");
      qdd_hip5_x = (DoubleYoVariable)rob.getVariable("qdd_hip5_x");
      tau_hip5_x = (DoubleYoVariable)rob.getVariable("tau_hip5_x");
      tau_damp_hip5_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip5_x");
      q_knee5 = (DoubleYoVariable)rob.getVariable("q_knee5");
      qd_knee5 = (DoubleYoVariable)rob.getVariable("qd_knee5");
      qdd_knee5 = (DoubleYoVariable)rob.getVariable("qdd_knee5");
      tau_knee5 = (DoubleYoVariable)rob.getVariable("tau_knee5");
      tau_damp_knee5 = (DoubleYoVariable)rob.getVariable("tau_damp_knee5");
      gc_foot5_x = (DoubleYoVariable)rob.getVariable("gc_foot5_x");
      gc_foot5_y = (DoubleYoVariable)rob.getVariable("gc_foot5_y");
      gc_foot5_z = (DoubleYoVariable)rob.getVariable("gc_foot5_z");
      gc_foot5_dx = (DoubleYoVariable)rob.getVariable("gc_foot5_dx");
      gc_foot5_dy = (DoubleYoVariable)rob.getVariable("gc_foot5_dy");
      gc_foot5_dz = (DoubleYoVariable)rob.getVariable("gc_foot5_dz");
      gc_foot5_fx = (DoubleYoVariable)rob.getVariable("gc_foot5_fx");
      gc_foot5_fy = (DoubleYoVariable)rob.getVariable("gc_foot5_fy");
      gc_foot5_fz = (DoubleYoVariable)rob.getVariable("gc_foot5_fz");
      gc_foot5_px = (DoubleYoVariable)rob.getVariable("gc_foot5_px");
      gc_foot5_py = (DoubleYoVariable)rob.getVariable("gc_foot5_py");
      gc_foot5_pz = (DoubleYoVariable)rob.getVariable("gc_foot5_pz");
      gc_foot5_tdx = (DoubleYoVariable)rob.getVariable("gc_foot5_tdx");
      gc_foot5_tdy = (DoubleYoVariable)rob.getVariable("gc_foot5_tdy");
      gc_foot5_tdz = (DoubleYoVariable)rob.getVariable("gc_foot5_tdz");
      gc_foot5_fs = (DoubleYoVariable)rob.getVariable("gc_foot5_fs");
      gc_foot5_slip = (DoubleYoVariable)rob.getVariable("gc_foot5_slip");
      gc_foot5_coll = (DoubleYoVariable)rob.getVariable("gc_foot5_coll");
      q_hip6_z = (DoubleYoVariable)rob.getVariable("q_hip6_z");
      qd_hip6_z = (DoubleYoVariable)rob.getVariable("qd_hip6_z");
      qdd_hip6_z = (DoubleYoVariable)rob.getVariable("qdd_hip6_z");
      tau_hip6_z = (DoubleYoVariable)rob.getVariable("tau_hip6_z");
      tau_damp_hip6_z = (DoubleYoVariable)rob.getVariable("tau_damp_hip6_z");
      q_hip6_x = (DoubleYoVariable)rob.getVariable("q_hip6_x");
      qd_hip6_x = (DoubleYoVariable)rob.getVariable("qd_hip6_x");
      qdd_hip6_x = (DoubleYoVariable)rob.getVariable("qdd_hip6_x");
      tau_hip6_x = (DoubleYoVariable)rob.getVariable("tau_hip6_x");
      tau_damp_hip6_x = (DoubleYoVariable)rob.getVariable("tau_damp_hip6_x");
      q_knee6 = (DoubleYoVariable)rob.getVariable("q_knee6");
      qd_knee6 = (DoubleYoVariable)rob.getVariable("qd_knee6");
      qdd_knee6 = (DoubleYoVariable)rob.getVariable("qdd_knee6");
      tau_knee6 = (DoubleYoVariable)rob.getVariable("tau_knee6");
      tau_damp_knee6 = (DoubleYoVariable)rob.getVariable("tau_damp_knee6");
      gc_foot6_x = (DoubleYoVariable)rob.getVariable("gc_foot6_x");
      gc_foot6_y = (DoubleYoVariable)rob.getVariable("gc_foot6_y");
      gc_foot6_z = (DoubleYoVariable)rob.getVariable("gc_foot6_z");
      gc_foot6_dx = (DoubleYoVariable)rob.getVariable("gc_foot6_dx");
      gc_foot6_dy = (DoubleYoVariable)rob.getVariable("gc_foot6_dy");
      gc_foot6_dz = (DoubleYoVariable)rob.getVariable("gc_foot6_dz");
      gc_foot6_fx = (DoubleYoVariable)rob.getVariable("gc_foot6_fx");
      gc_foot6_fy = (DoubleYoVariable)rob.getVariable("gc_foot6_fy");
      gc_foot6_fz = (DoubleYoVariable)rob.getVariable("gc_foot6_fz");
      gc_foot6_px = (DoubleYoVariable)rob.getVariable("gc_foot6_px");
      gc_foot6_py = (DoubleYoVariable)rob.getVariable("gc_foot6_py");
      gc_foot6_pz = (DoubleYoVariable)rob.getVariable("gc_foot6_pz");
      gc_foot6_tdx = (DoubleYoVariable)rob.getVariable("gc_foot6_tdx");
      gc_foot6_tdy = (DoubleYoVariable)rob.getVariable("gc_foot6_tdy");
      gc_foot6_tdz = (DoubleYoVariable)rob.getVariable("gc_foot6_tdz");
      gc_foot6_fs = (DoubleYoVariable)rob.getVariable("gc_foot6_fs");
      gc_foot6_slip = (DoubleYoVariable)rob.getVariable("gc_foot6_slip");
      gc_foot6_coll = (DoubleYoVariable)rob.getVariable("gc_foot6_coll");
      q_pend1 = (DoubleYoVariable)rob.getVariable("q_pend1");
      qd_pend1 = (DoubleYoVariable)rob.getVariable("qd_pend1");
      qdd_pend1 = (DoubleYoVariable)rob.getVariable("qdd_pend1");
      tau_pend1 = (DoubleYoVariable)rob.getVariable("tau_pend1");
      q_pend2 = (DoubleYoVariable)rob.getVariable("q_pend2");
      qd_pend2 = (DoubleYoVariable)rob.getVariable("qd_pend2");
      qdd_pend2 = (DoubleYoVariable)rob.getVariable("qdd_pend2");
      tau_pend2 = (DoubleYoVariable)rob.getVariable("tau_pend2");
      gc_pend_end_x = (DoubleYoVariable)rob.getVariable("gc_pend_end_x");
      gc_pend_end_y = (DoubleYoVariable)rob.getVariable("gc_pend_end_y");
      gc_pend_end_z = (DoubleYoVariable)rob.getVariable("gc_pend_end_z");
      gc_pend_end_dx = (DoubleYoVariable)rob.getVariable("gc_pend_end_dx");
      gc_pend_end_dy = (DoubleYoVariable)rob.getVariable("gc_pend_end_dy");
      gc_pend_end_dz = (DoubleYoVariable)rob.getVariable("gc_pend_end_dz");
      gc_pend_end_fx = (DoubleYoVariable)rob.getVariable("gc_pend_end_fx");
      gc_pend_end_fy = (DoubleYoVariable)rob.getVariable("gc_pend_end_fy");
      gc_pend_end_fz = (DoubleYoVariable)rob.getVariable("gc_pend_end_fz");
      gc_pend_end_px = (DoubleYoVariable)rob.getVariable("gc_pend_end_px");
      gc_pend_end_py = (DoubleYoVariable)rob.getVariable("gc_pend_end_py");
      gc_pend_end_pz = (DoubleYoVariable)rob.getVariable("gc_pend_end_pz");
      gc_pend_end_tdx = (DoubleYoVariable)rob.getVariable("gc_pend_end_tdx");
      gc_pend_end_tdy = (DoubleYoVariable)rob.getVariable("gc_pend_end_tdy");
      gc_pend_end_tdz = (DoubleYoVariable)rob.getVariable("gc_pend_end_tdz");
      gc_pend_end_fs = (DoubleYoVariable)rob.getVariable("gc_pend_end_fs");
      gc_pend_end_slip = (DoubleYoVariable)rob.getVariable("gc_pend_end_slip");
      gc_pend_end_coll = (DoubleYoVariable)rob.getVariable("gc_pend_end_coll");

   }
}
