package com.yobotics.exampleSimulations.doublePendulum;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.UnknownHostException;

public class ExternalControllerClient extends Thread implements Runnable
{
   Socket clientSocket;
   String sName;
   long starttime = 0;

   boolean DEBUG = false;

   public ExternalControllerClient(String sName, int port)
   {
      this.sName = sName;

      try
      {
         clientSocket = new Socket(sName, port);
      }
      catch (UnknownHostException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (IOException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
   }

   public void run()
   {
      try
      {
         starttime = System.currentTimeMillis();
         DataInputStream in = new DataInputStream(clientSocket.getInputStream());
         DataOutputStream outToServer = new DataOutputStream(clientSocket.getOutputStream());
         BufferedReader inFromServer = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));


         System.out.println("sending:");
         System.out.println("q_joint1,q_joint2,qd_joint1,qd_joint2");
         outToServer.writeBytes("q_joint1,q_joint2,qd_joint1,qd_joint2\n");
         System.out.println("sending:");
         System.out.println("tau_joint1,tau_joint2");
         outToServer.writeBytes("tau_joint1,tau_joint2\n");

         System.out.println("sending 0.05");
         outToServer.writeDouble(0.1);
         System.out.println("sending 0.02");
         outToServer.writeDouble(0.2);
         System.out.println("sending 0.0");
         outToServer.writeDouble(0.0);
         System.out.println("sending 0.0");
         outToServer.writeDouble(0.0);

         System.out.println("waiting");


         boolean stop = false;

         // int datasize = 0;

         // int processed = 0;

         // Receive Data!

         while (!stop)
         {
            if (DEBUG)
               System.out.println("top of loop");
            double[] darr = new double[4];
            stop = true;

            while (in.available() <= 0)
            {
               try
               {
                  sleep(1);
               }
               catch (InterruptedException e)
               {
               }
            }

            if (DEBUG)
               System.out.println("Reading From Server");

            for (int i = 0; i < 4; i++)
            {
               try
               {
                  // Store the read data into darr Array
                  darr[i] = in.readDouble();
                  if (DEBUG)
                     System.out.print(darr[i] + ",");

                  // if (darr[i] != -1.0)
                  stop = false;
               }
               catch (EOFException xcp)
               {
                  if (!stop)
                  {
                     xcp.printStackTrace();
                     stop = true;

                     break;
                  }
               }

               if (DEBUG)
                  System.out.println();
            }

            // processed++;
            // if(DEBUG)System.out.println("Processed " + processed +
            // " rows of data");

            // DO USEFUL SOMETHING WITH THE DATA =)!

            // if(DEBUG)System.out.println(i + " " + darr[i]);

            // Prepare and send TAU's
            if (DEBUG)
               System.out.println("Writting To Server");

//          for (int i = 0; i < tau_count; i++)
//          {
//             if (DEBUG)
//                System.out.print(0.0 + ",");
//
//             // Send torques back!
//             // outToServer.writeDouble(Math.random() * 100 - 50);
//
//          }

            outToServer.writeDouble(0);


            double tau_joint2 = 242.52 * darr[0] + 96.33 * darr[1] + 104.59 * darr[2] + 49.05 * darr[3];
            outToServer.writeDouble(tau_joint2);



            if (DEBUG)
               System.out.println();

            long diff = System.currentTimeMillis() - starttime;
            if (DEBUG)
               System.out.println("Reading/Writing took " + (diff / 1000.0) + " secs.");
         }

         // in.close();
         // clientSocket.close();
         // clientSocket = null;

      }
      catch (Exception e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
   }

   public static void main(String[] args)
   {
      Thread tmp = new Thread(new ExternalControllerClient("localhost", 8085));
      tmp.start();
   }
}
