package com.yobotics.exampleSimulations.fallingBrick;

import com.yobotics.simulationconstructionset.SimulationConstructionSet;
import com.yobotics.simulationconstructionset.YoAppearance;

public class FallingBrickSimulation
{
   SimulationConstructionSet sim;

   public FallingBrickSimulation()
   {
      FallingBrickRobot FallingBrick = new FallingBrickRobot();
      sim = new SimulationConstructionSet(FallingBrick);

      sim.setDT(0.001, 20);

      sim.setCameraPosition(-1.5, -2.5, 0.5);
      sim.setCameraFix(0.0, 0.0, 0.4);

      sim.setCameraTracking(false, true, true, false);
      sim.setCameraDolly(false, true, true, false);

      // Set up some graphs:
      sim.setupGraph("q_z");

      sim.setupEntryBox("qd_x");
      sim.setupEntryBox("qd_y");
      sim.setupEntryBox("qd_z");

      sim.setupEntryBox("qd_wx");
      sim.setupEntryBox("qd_wy");
      sim.setupEntryBox("qd_wz");

      sim.setGroundAppearance(YoAppearance.EarthTexture(null));
      // sim.setGroundAppearance(YoAppearance.StoneTexture(null));
      // sim.setGroundAppearance(YoAppearance.AluminumMaterial());

      Thread myThread = new Thread(sim);
      myThread.start();

   }

   public static void main(String[] args)
   {
      new FallingBrickSimulation();
   }
}
