package us.ihmc.exampleSimulations.harmonograph;


import com.yobotics.simulationconstructionset.SimulationConstructionSet;
import com.yobotics.simulationconstructionset.util.graphics.DynamicGraphicObjectsListRegistry;

public class HarmonographSimulation
{

   private static final double simulateDT = 0.0002;
   private static final int recordFrequency = 100;


   public HarmonographSimulation()
   {
      DynamicGraphicObjectsListRegistry dynamicGraphicObjectsListRegistry = new DynamicGraphicObjectsListRegistry();
      HarmonographRobot robot = new HarmonographRobot(dynamicGraphicObjectsListRegistry);
      
      SimulationConstructionSet simulationConstructionSet = new SimulationConstructionSet(robot);
      dynamicGraphicObjectsListRegistry.addDynamicGraphicsObjectListsToSimulationConstructionSet(simulationConstructionSet);
      
      simulationConstructionSet.setDT(simulateDT, recordFrequency);
      
      HarmonographPaperJPanel harmonographPaperJPanel = robot.getHarmonographPaperJPanel();
      simulationConstructionSet.addExtraJpanel(harmonographPaperJPanel, "Harmonograph Paper");
      
      Thread thread = new Thread(simulationConstructionSet);
      thread.start();
   }
   
   
   public static void main(String[] args)
   {
      new HarmonographSimulation();
   }

}
